Package org.jboss.resteasy.core.providerfactory

## Class CommonProviders

- java.lang.Object
- - org.jboss.resteasy.core.providerfactory.CommonProviders

- Direct Known Subclasses:
    `ClientHelper`, `ServerHelper`

      public class CommonProviders
      extends Object

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected boolean` | `attachedFeatures` |
    `protected boolean` | `attachedMessageBodyReaders` |
    `protected boolean` | `attachedMessageBodyWriters` |
    `protected boolean` | `attachedReaderInterceptors` |
    `protected boolean` | `attachedWriterInterceptors` |
    `protected Set<javax.ws.rs.container.DynamicFeature>` | `dynamicFeatures` |
    `protected boolean` | `lockSnapshots` |
    `protected MediaTypeMap<SortedKey<javax.ws.rs.ext.MessageBodyReader>>` | `messageBodyReaders` |
    `protected MediaTypeMap<SortedKey<javax.ws.rs.ext.MessageBodyWriter>>` | `messageBodyWriters` |
    `protected JaxrsInterceptorRegistry<javax.ws.rs.ext.ReaderInterceptor>` | `readerInterceptorRegistry` |
    `protected ResteasyProviderFactoryImpl` | `rpf` |
    `protected JaxrsInterceptorRegistry<javax.ws.rs.ext.WriterInterceptor>` | `writerInterceptorRegistry` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `CommonProviders​(ResteasyProviderFactoryImpl rpf)` |
    `CommonProviders​(ResteasyProviderFactoryImpl rpf, CommonProviders parent)` | Shallow Copy of a parent.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addCompositeWildcardMBR​(javax.ws.rs.core.MediaType mediaType, SortedKey<javax.ws.rs.ext.MessageBodyReader> mbr, String baseSubtype)` |
    `void` | `addCompositeWildcardMBW​(javax.ws.rs.core.MediaType mediaType, SortedKey<javax.ws.rs.ext.MessageBodyWriter> mbw, String baseSubtype)` |
    `void` | `addDynamicFeature​(Class provider)` |
    `protected void` | `addMessageBodyReader​(javax.ws.rs.ext.MessageBodyReader provider, Class<?> providerClass, int priority, boolean isBuiltin)` |
    `protected void` | `addMessageBodyWriter​(javax.ws.rs.ext.MessageBodyWriter provider, Class<?> providerClass, int priority, boolean isBuiltin)` |
    `void` | `addReaderInterceptor​(Class provider, int priority)` |
    `void` | `addRegularMBR​(javax.ws.rs.core.MediaType mediaType, SortedKey<javax.ws.rs.ext.MessageBodyReader> mbr)` |
    `void` | `addRegularMBW​(javax.ws.rs.core.MediaType mediaType, SortedKey<javax.ws.rs.ext.MessageBodyWriter> mbw)` |
    `void` | `addSubtypeWildMBR​(javax.ws.rs.core.MediaType mediaType, SortedKey<javax.ws.rs.ext.MessageBodyReader> mbr)` |
    `void` | `addSubtypeWildMBW​(javax.ws.rs.core.MediaType mediaType, SortedKey<javax.ws.rs.ext.MessageBodyWriter> mbw)` |
    `void` | `addWildcardCompositeMBR​(javax.ws.rs.core.MediaType mediaType, SortedKey<javax.ws.rs.ext.MessageBodyReader> mbr, String baseSubtype)` |
    `void` | `addWildcardCompositeMBW​(javax.ws.rs.core.MediaType mediaType, SortedKey<javax.ws.rs.ext.MessageBodyWriter> mbw, String baseSubtype)` |
    `void` | `addWildcardMBR​(SortedKey<javax.ws.rs.ext.MessageBodyReader> mbr)` |
    `void` | `addWildcardMBW​(SortedKey<javax.ws.rs.ext.MessageBodyWriter> mbw)` |
    `void` | `addWriterInterceptor​(Class provider, int priority)` |
    `Set<javax.ws.rs.container.DynamicFeature>` | `getDynamicFeatures()` |
    `protected Set<javax.ws.rs.container.DynamicFeature>` | `getDynamicFeaturesForWrite()` |
    `MediaTypeMap<SortedKey<javax.ws.rs.ext.MessageBodyReader>>` | `getMessageBodyReaders()` |
    `protected MediaTypeMap<SortedKey<javax.ws.rs.ext.MessageBodyReader>>` | `getMessageBodyReadersForWrite()` |
    `MediaTypeMap<SortedKey<javax.ws.rs.ext.MessageBodyWriter>>` | `getMessageBodyWriters()` |
    `protected MediaTypeMap<SortedKey<javax.ws.rs.ext.MessageBodyWriter>>` | `getMessageBodyWritersForWrite()` |
    `JaxrsInterceptorRegistry<javax.ws.rs.ext.ReaderInterceptor>` | `getReaderInterceptorRegistry()` |
    `protected JaxrsInterceptorRegistry<javax.ws.rs.ext.ReaderInterceptor>` | `getReaderInterceptorRegistryForWrite()` |
    `JaxrsInterceptorRegistry<javax.ws.rs.ext.WriterInterceptor>` | `getWriterInterceptorRegistry()` |
    `protected JaxrsInterceptorRegistry<javax.ws.rs.ext.WriterInterceptor>` | `getWriterInterceptorRegistryForWrite()` |
    `void` | `lockSnapshots()` |
    `protected void` | `processProviderContracts​(Class provider, Integer priorityOverride, boolean isBuiltin, Map<Class<?>,​Integer> contracts, Map<Class<?>,​Integer> newContracts)` |
    `protected void` | `processProviderInstanceContracts​(Object provider, Map<Class<?>,​Integer> contracts, Integer priorityOverride, boolean builtIn, Map<Class<?>,​Integer> newContracts)` |

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### rpf

          protected ResteasyProviderFactoryImpl rpf

    - #### lockSnapshots

          protected boolean lockSnapshots

    - #### attachedMessageBodyReaders

          protected boolean attachedMessageBodyReaders

    - #### messageBodyReaders

          protected volatile MediaTypeMap<SortedKey<javax.ws.rs.ext.MessageBodyReader>> messageBodyReaders

    - #### attachedMessageBodyWriters

          protected boolean attachedMessageBodyWriters

    - #### messageBodyWriters

          protected volatile MediaTypeMap<SortedKey<javax.ws.rs.ext.MessageBodyWriter>> messageBodyWriters

    - #### attachedReaderInterceptors

          protected boolean attachedReaderInterceptors

    - #### readerInterceptorRegistry

          protected volatile JaxrsInterceptorRegistry<javax.ws.rs.ext.ReaderInterceptor> readerInterceptorRegistry

    - #### attachedWriterInterceptors

          protected boolean attachedWriterInterceptors

    - #### writerInterceptorRegistry

          protected volatile JaxrsInterceptorRegistry<javax.ws.rs.ext.WriterInterceptor> writerInterceptorRegistry

    - #### attachedFeatures

          protected boolean attachedFeatures

    - #### dynamicFeatures

          protected volatile Set<javax.ws.rs.container.DynamicFeature> dynamicFeatures

  - ### Constructor Detail

    - #### CommonProviders

          public CommonProviders​(ResteasyProviderFactoryImpl rpf)

    - #### CommonProviders

          public CommonProviders​(ResteasyProviderFactoryImpl rpf,
                                 CommonProviders parent)

      Shallow Copy of a parent.
      Parameters:
        `rpf` -
        `parent` -

  - ### Method Detail

    - #### processProviderContracts

          protected void processProviderContracts​(Class provider,
                                                  Integer priorityOverride,
                                                  boolean isBuiltin,
                                                  Map<Class<?>,​Integer> contracts,
                                                  Map<Class<?>,​Integer> newContracts)

    - #### processProviderInstanceContracts

          protected void processProviderInstanceContracts​(Object provider,
                                                          Map<Class<?>,​Integer> contracts,
                                                          Integer priorityOverride,
                                                          boolean builtIn,
                                                          Map<Class<?>,​Integer> newContracts)

    - #### addMessageBodyReader

          protected void addMessageBodyReader​(javax.ws.rs.ext.MessageBodyReader provider,
                                              Class<?> providerClass,
                                              int priority,
                                              boolean isBuiltin)

    - #### addMessageBodyWriter

          protected void addMessageBodyWriter​(javax.ws.rs.ext.MessageBodyWriter provider,
                                              Class<?> providerClass,
                                              int priority,
                                              boolean isBuiltin)

    - #### getMessageBodyReadersForWrite

          protected MediaTypeMap<SortedKey<javax.ws.rs.ext.MessageBodyReader>> getMessageBodyReadersForWrite()

    - #### getMessageBodyWritersForWrite

          protected MediaTypeMap<SortedKey<javax.ws.rs.ext.MessageBodyWriter>> getMessageBodyWritersForWrite()

    - #### getReaderInterceptorRegistryForWrite

          protected JaxrsInterceptorRegistry<javax.ws.rs.ext.ReaderInterceptor> getReaderInterceptorRegistryForWrite()

    - #### getWriterInterceptorRegistryForWrite

          protected JaxrsInterceptorRegistry<javax.ws.rs.ext.WriterInterceptor> getWriterInterceptorRegistryForWrite()

    - #### getDynamicFeaturesForWrite

          protected Set<javax.ws.rs.container.DynamicFeature> getDynamicFeaturesForWrite()

    - #### getMessageBodyReaders

          public MediaTypeMap<SortedKey<javax.ws.rs.ext.MessageBodyReader>> getMessageBodyReaders()

    - #### getMessageBodyWriters

          public MediaTypeMap<SortedKey<javax.ws.rs.ext.MessageBodyWriter>> getMessageBodyWriters()

    - #### getReaderInterceptorRegistry

          public JaxrsInterceptorRegistry<javax.ws.rs.ext.ReaderInterceptor> getReaderInterceptorRegistry()

    - #### getWriterInterceptorRegistry

          public JaxrsInterceptorRegistry<javax.ws.rs.ext.WriterInterceptor> getWriterInterceptorRegistry()

    - #### getDynamicFeatures

          public Set<javax.ws.rs.container.DynamicFeature> getDynamicFeatures()

    - #### lockSnapshots

          public void lockSnapshots()

    - #### addDynamicFeature

          public void addDynamicFeature​(Class provider)

    - #### addWriterInterceptor

          public void addWriterInterceptor​(Class provider,
                                           int priority)

    - #### addReaderInterceptor

          public void addReaderInterceptor​(Class provider,
                                           int priority)

    - #### addWildcardMBR

          public void addWildcardMBR​(SortedKey<javax.ws.rs.ext.MessageBodyReader> mbr)

    - #### addSubtypeWildMBR

          public void addSubtypeWildMBR​(javax.ws.rs.core.MediaType mediaType,
                                        SortedKey<javax.ws.rs.ext.MessageBodyReader> mbr)

    - #### addRegularMBR

          public void addRegularMBR​(javax.ws.rs.core.MediaType mediaType,
                                    SortedKey<javax.ws.rs.ext.MessageBodyReader> mbr)

    - #### addCompositeWildcardMBR

          public void addCompositeWildcardMBR​(javax.ws.rs.core.MediaType mediaType,
                                              SortedKey<javax.ws.rs.ext.MessageBodyReader> mbr,
                                              String baseSubtype)

    - #### addWildcardCompositeMBR

          public void addWildcardCompositeMBR​(javax.ws.rs.core.MediaType mediaType,
                                              SortedKey<javax.ws.rs.ext.MessageBodyReader> mbr,
                                              String baseSubtype)

    - #### addWildcardMBW

          public void addWildcardMBW​(SortedKey<javax.ws.rs.ext.MessageBodyWriter> mbw)

    - #### addRegularMBW

          public void addRegularMBW​(javax.ws.rs.core.MediaType mediaType,
                                    SortedKey<javax.ws.rs.ext.MessageBodyWriter> mbw)

    - #### addSubtypeWildMBW

          public void addSubtypeWildMBW​(javax.ws.rs.core.MediaType mediaType,
                                        SortedKey<javax.ws.rs.ext.MessageBodyWriter> mbw)

    - #### addCompositeWildcardMBW

          public void addCompositeWildcardMBW​(javax.ws.rs.core.MediaType mediaType,
                                              SortedKey<javax.ws.rs.ext.MessageBodyWriter> mbw,
                                              String baseSubtype)

    - #### addWildcardCompositeMBW

          public void addWildcardCompositeMBW​(javax.ws.rs.core.MediaType mediaType,
                                              SortedKey<javax.ws.rs.ext.MessageBodyWriter> mbw,
                                              String baseSubtype)